#ifndef _GAME
#define _GAME

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <allegro.h>

#include "player.h"
#include "table.h"
#include "ball.h"
#include "vector.h"
#include "physics.h"
#include "interface.h"
#include "sound.h"
#include "menu.h"

typedef struct {
	player* playerArray;
	int totalPlayers;
	int current;

	table* table;

	ball* ballArray;
	int totalBalls;

	BITMAP* painel;

	sounds sounds;
} Game;

Game* loadGame (int totalPlayers, int totalBalls);
void initializeGame (Game* game);
void drawGame (Game* game);
void respawnCueBall (Game* game);
int turnEnded (ball* ballArray, int totalBalls);
void playersTurn(Game* game, int* choice);
void physicsInterface (Game* game, int* deadBalls, int* fstCollision);
int checkCueBallStatus (Game* game);
void executeShot (Game* game, int* fstCollision, int* dead_balls);

#endif
