/*
  Copyright (C) 2007 Roberto Carraretto & Thiago Fassina Olimpio Carvalho

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <allegro.h>

#include "multiplayer.h"
#include "interface.h"
#include "menu.h"
#include "server.h"


int set_mod (char* str) {
	return(((str[0] - 48) * 10) + (str[1] - 48));
}


void start_game (gameConfig* config) {

	char mod_detector[3];

	if (config->choice == JOIN) {
		recebe(mod_detector, config->socket);
		config->mod = set_mod(mod_detector);
		printf ("Host is playing mod -> [%d]\n",config->mod);
	}

	//redireciona para o mod escolhido
	if (config->mod == KK) {
		mod_kk(config);
	}
	if (config->mod == EOO) {
		printf ("Mod not available yet.\n");
		//mod_eoo(config);
	}

}


int main (void) {

	// Inicializa modulos do allegro
	initializeInterface();
	gameConfig config;
	config.choice = DEFAULT;
	strcpy(config.playerName, "Nameless");

	while (config.choice != EXIT) { //NOTE BY TG: I never wished to do this.

		start_menu(&config); //roda o menu principal e configura o jogo
	
		//caso o jogador opte por multiplayer, a conexão é estabelecida
		if (config.choice != SINGLE) {
			config.socket = start_connection(&config);
		}

		start_game(&config); //let's do this
	}

	allegro_exit();
	return(0);
}
END_OF_MAIN();
