/*
  Copyright (C) 2007 Roberto Carraretto & Thiago Fassina Olimpio Carvalho

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "menu.h"

// Funcao executada, a cada ciclo, que verifica o estado dos botoes no menu principal.. blah
int my_button_proc (int msg, DIALOG *d, int c) {
	int ret = d_button_proc (msg, d, c);

	if (ret == D_CLOSE) {
		d->d2 = 1; // foi ativado
		if (d->dp3) // tem funcao agregada ao botao
			return ((int (*)(void))d->dp3)();
		else
			return ret; // D_CLOSE - 1
	}

	return ret;
}

void initializeDialog (DIALOG* d, int size) {
	int i;
	for (i=0; i <= size; i++) {
		d[i].d2 = 0;
	}
}

int set_port (char* str) {
	int i = 0;
	int port = 0;
	while (str[i] != '\0') {
		port = 10*port;
		port += (str[i] - 48);
		i++;
	}
	return(port);
}

char playerName[LEN];
char ip[LEN];
char port_join[LEN];
char port_host[LEN];

DIALOG mainMenu[] =
{
	{ d_clear_proc,        0,   0,    0,    0,   0,  0,    0,        0,          0,       0,               NULL,    NULL, NULL  },
	/* (dialog proc)      (x)   (y)   (w)   (h) (fg)(bg) (key)  (flags)        (d1)     (d2)                (dp)    (dp2) (dp3) */
	{ d_text_proc,        50,   20,    0,    0,   0,  0,    0,       0,          0,       0,    "SinucaOS Menu",    NULL, NULL  },
	{ my_button_proc,     20,   40,  160,   20,   0,  0,  'S', D_CLOSE,     SINGLE,       0,   "&Single Player",    NULL, NULL  },
	{ my_button_proc,     20,   60,  160,   20,   0,  0,  'M', D_CLOSE,      MULTI,       0,     "&Multiplayer",    NULL, NULL  },
	{ my_button_proc,     20,   80,  160,   20,   0,  0,  'O', D_CLOSE,    OPTIONS,       0,         "&Options",    NULL, NULL  },
	{ my_button_proc,     20,   100, 160,   20,   0,  0,  'C', D_CLOSE,    CREDITS,       0,         "&Credits",    NULL, NULL  },
	{ my_button_proc,     20,   120, 160,   20,   0,  0,  'E', D_CLOSE,       EXIT,       0,            "&Exit",    NULL, NULL  },
};

DIALOG multiplayer[] =
{
	{ d_clear_proc,        0,   0,    0,    0,   0,  0,    0,        0,          0,       0,               NULL,    NULL, NULL  },
	/* (dialog proc)      (x)   (y)   (w)   (h) (fg)(bg) (key)  (flags)        (d1)     (d2)                (dp)    (dp2) (dp3) */
	{ d_text_proc,        50,   20,    0,    0,   0,  0,    0,       0,          0,       0,      "Multiplayer",    NULL, NULL  },
	{ d_text_proc,        20,   60,    0,    0,   0,  0,    0,       0,          0,       0,"Join Game(IP/Port)",   NULL, NULL  },
	{ d_edit_proc,        20,   70,  160,    8,   0,  0,    0,       0,        LEN,       0,                 ip,    NULL, NULL  },
	{ d_edit_proc,        20,   80,  160,    8,   0,  0,    0,       0,        LEN,       0,          port_join,    NULL, NULL  },
	{ my_button_proc,     20,   90,  160,   20,   0,  0,  'J', D_CLOSE,       JOIN,       0,            "&Join",    NULL, NULL  },
	{ d_text_proc,        20,  130,    0,    0,   0,  0,    0,       0,          0,       0,"Create Game(Port)",    NULL, NULL  },
	{ d_edit_proc,        20,  140,  160,    8,   0,  0,    0,       0,        LEN,       0,          port_host,    NULL, NULL  },
	{ my_button_proc,     20,  150,  160,   20,   0,  0,  'C', D_CLOSE,     CREATE,       0,          "&Create",    NULL, NULL  },
	{ my_button_proc,     20,  190,  160,   20,   0,  0,  'B', D_CLOSE,       BACK,       0,            "&Back",    NULL, NULL  },
};

DIALOG optionsMenu[] =
{
	{ d_clear_proc,        0,   0,    0,    0,   0,  0,    0,        0,          0,      0,               NULL,    NULL, NULL  },
	/* (dialog proc)      (x)   (y)   (w)   (h) (fg)(bg) (key)  (flags)        (d1)     (d2)                (dp)    (dp2) (dp3) */
	{ d_text_proc,        50,   20,    0,    0,   0,  0,    0,       0,          0,       0,          "Options",    NULL, NULL  },
	{ d_text_proc,        20,   60,    0,    0,   0,  0,    0,       0,          0,       0,      "Player Name",    NULL, NULL  },
	{ d_edit_proc,        20,   70,  160,    8,   0,  0,    0,       0,        LEN,       0,         playerName,    NULL, NULL  },
	{ d_check_proc,       20,   90,  160,   20,   0,  0,  'V',       2,          0,       0,          "&Volume",    NULL, NULL  },
	{ d_slider_proc,      20,  110,  160,   12,   0,  0,    0,       0,         50,      50,               NULL,    NULL, NULL  },
	{ my_button_proc,     20,  150,  160,   20,   0,  0,  'B', D_CLOSE,       BACK,       0,            "&Back",    NULL, NULL  },
};

DIALOG modMenu[] =
{
	{ d_clear_proc,        0,   0,    0,    0,   0,  0,    0,        0,          0,       0,               NULL,    NULL, NULL  },
	/* (dialog proc)      (x)   (y)   (w)   (h) (fg)(bg) (key)  (flags)        (d1)     (d2)                (dp)    (dp2) (dp3) */
	{ d_text_proc,        50,   20,    0,    0,   0,  0,    0,       0,          0,       0,    "SinucaOS Menu",    NULL, NULL  },
	{ my_button_proc,     20,   40,  160,   20,   0,  0,  'K', D_CLOSE,          0,       0,       "&Kill Kill",    NULL, NULL  },
	{ my_button_proc,     20,   60,  160,   20,   0,  0,  'E', D_CLOSE,          0,       0,     "&Even or Odd",    NULL, NULL  },
	{ my_button_proc,     20,   80,  160,   20,   0,  0,  'B', D_CLOSE,          0,       0,            "&Back",    NULL, NULL  },
};

DIALOG ingameMenu[] =
{
	{ d_clear_proc,        0,   0,    0,    0,   0,  0,    0,        0,          0,       0,               NULL,    NULL, NULL  },
	/* (dialog proc)      (x)   (y)   (w)   (h) (fg)(bg) (key)  (flags)        (d1)     (d2)                (dp)    (dp2) (dp3) */
	{ d_text_proc,        50,   20,    0,    0,   0,  0,    0,       0,          0,       0,    "SinucaOS Menu",    NULL, NULL  },
	{ my_button_proc,     20,   40,  160,   20,   0,  0,  'R', D_CLOSE,          0,       0,          "&Resume",    NULL, NULL  },
	{ my_button_proc,     20,   60,  160,   20,   0,  0,  'G', D_CLOSE,          0,       0,      "Reset &Game",    NULL, NULL  },
	{ my_button_proc,     20,   80,  160,   20,   0,  0,  'E', D_CLOSE,          0,       0,            "&Exit",    NULL, NULL  },
};


void ingame_menu (int* choice) {

	initializeDialog (ingameMenu, 5);
	do_dialog(ingameMenu, -1);

	while (1) {
		if (ingameMenu[2].d2) {
			*choice = BACK;
			return;
		}
		if (ingameMenu[3].d2) {
			*choice = MAIN;
			return;
		}
		if (ingameMenu[4].d2) {
			*choice = EXIT;
			return;
		}
		if (key[KEY_ESC]) {
			*choice = BACK;
			return;
		}
		rest(100);
	}
}

void mod_menu (int* choice) {

	initializeDialog (modMenu, 5);
	do_dialog(modMenu, -1);

	while (!key[KEY_ESC]) {
		if (modMenu[2].d2) {
			*choice = KK;
			return;
		}
		if (modMenu[3].d2) {
			*choice = EOO;
			return;
		}
		if (modMenu[4].d2) {
			*choice = BACK;
			return;
		}
		rest(100);
	}
	*choice = BACK;
	rest(100);
	return;
}


void main_menu (gameConfig *config) {

	//vamo que vamo
	initializeDialog (mainMenu, 7);
	do_dialog(mainMenu, -1);

	//qual botão foi acionado?
	config->choice = DEFAULT;
	int i;
	while (!(config->choice)) {
		for (i = 1; i <= 7; i++) {
			if (mainMenu[i].d2) {
				config->choice = mainMenu[i].d1;
			}
			if (key[KEY_ESC]) {
				config->choice = EXIT;
			}
		}
		rest(100);
	}
}

void options_menu (gameConfig* config) {

	initializeDialog (optionsMenu, 7);
	do_dialog(optionsMenu, -1);

	while (config->choice != BACK) {
		if (optionsMenu[6].d2) {
			config->choice = BACK;
		}
		if (key[KEY_ESC]) {
			config->choice = BACK;
		}
		rest(100);
	}
	config->volume = (optionsMenu[5].d2 * (optionsMenu[4].flags));
	if (playerName[0] != '\0') {
		strcpy(config->playerName, playerName);
	}
	printf ("     Player name -> [%s]\n",config->playerName);
	printf ("     Volume      -> [%d%%]\n",config->volume);
}

void multiplayer_menu (gameConfig* config) {

	initializeDialog (multiplayer, 10);
	do_dialog(multiplayer, -1);

	config->choice = DEFAULT;
	while (!(config->choice)) {
		
		if (multiplayer[5].d2) {
			config->choice = JOIN;
		}
		if (multiplayer[8].d2) {
			config->choice = CREATE;
		}
		if (multiplayer[9].d2) {
			config->choice = BACK;
		}
		if (key[KEY_ESC]) {
			printf ("ESC no multi\n");
			config->choice = BACK;
		}
		rest(100);
	}

	if (config->choice == JOIN) {
		strcpy(config->ip, ip);
		config->port = set_port(port_join);
		printf ("     IP   -> [%s]\n     Port -> [%d]\n",config->ip, config->port);
		return;
	}

	if (config->choice == CREATE) {
		config->port = set_port(port_host);
		printf ("     Port -> [%d]\n",config->port);
		mod_menu(&config->mod);
		return;
	}
}

void start_menu (gameConfig* config) {
	//set up colors and position
	scare_mouse();
	gui_fg_color = makecol(0, 0, 0);
	gui_bg_color = makecol(120, 120, 120);
	set_dialog_color (mainMenu, gui_fg_color, gui_bg_color);
	set_dialog_color (optionsMenu, gui_fg_color, gui_bg_color);
	set_dialog_color (multiplayer, gui_fg_color, gui_bg_color);
	set_dialog_color (modMenu, gui_fg_color, gui_bg_color);
	set_dialog_color (ingameMenu, gui_fg_color, gui_bg_color);

	mainMenu[0].bg = makecol(0, 0, 0);
	optionsMenu[0].bg = makecol(0, 0, 0);
	multiplayer[0].bg = makecol(0, 0, 0);
	ingameMenu[0].bg = makecol(0, 0, 0);
	modMenu[0].bg = makecol(0, 0, 0);

	position_dialog (mainMenu, 320, 20);
	position_dialog (optionsMenu, 320, 20);
	position_dialog (multiplayer, 320, 20);
	position_dialog (ingameMenu, 320, 20);
	position_dialog (modMenu, 320, 20);

	//lets do this!
	config->choice = DEFAULT;
	while (config->choice == DEFAULT) {
		printf ("We're in the Main Menu.\n");
		main_menu(config);

		if (config->choice == SINGLE) {
			printf ("Single Player Selected.\n");
			mod_menu(&config->mod);
			config->choice = SINGLE;
		}

		if (config->choice == MULTI) {
			printf ("Multiplayer Selected.\n");
			multiplayer_menu(config);
		}

		if (config->choice == OPTIONS) {
			printf ("Options Menu Selected.\n");
			options_menu(config);
		}

		if (config->choice == CREDITS) {
			printf ("Not available yet.\n");
			config->choice = BACK;
		}

		if (config->choice == BACK) {
			config->choice = DEFAULT;
		}
		rest(100);
	}
}
//    \n    ||
