#ifndef _PHYSICS
#define _PHYSICS

#define FACTOR 0.001
#define ENERGY_LOSS 0.6

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <allegro.h>

#include "vector.h"
#include "ray.h"
#include "player.h"
#include "table.h"
#include "ball.h"
#include "sound.h"

void attrition (table* t, ball *b);
void movement (table* t, ball* b);
void inverseMovement (table* t, ball* b);

int* getCollisionOrder (ball* ballArray, int ballIndex, int totalBalls, int* totalCollisions);

// Boolean Check Collision Functions
int checkBallCollision (ball* a, ball* b, float* pDist);
int checkTableCollision (table* t, ball* b);
int checkHoleCollision (table* t, ball* b, int hole);
int checkBorderCollision (table* t, ball* b, int hole, int* index);

// Position Correction Functions
void fixBallCollision (ball* a, ball* b);
void fixTableCollision (table* t, ball* b, int collision);
void fixBorderCollision (ball* b, point p0, float angle);
void fixBorderCollision2 (ball* b, point p0, float angle);

// Speed Treatment Functions
void ballCollision (table* t, ball* a, ball* b);
int tableCollision (table* t, ball* b);
int holeAreaCollision (table* t, ball* b);

void hitCueBall (player* p, ball* cueBall);

#endif
