/*
  Copyright (C) 2007 Roberto Carraretto & Thiago Fassina Olimpio Carvalho

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "player.h"

float getStr (player* p) {
	return (p->strength);
}

float getAngle (player* p) {
	return (p->angle);
}

void setStr (player* p, float str) {
	p->strength = str;
}

void setAngle (player* p, float angle) {
	p->angle = angle;
}

void addAngle (player* p, float angle) {
	p->angle += angle;

	if (p->angle > 6.28) {
		p->angle -= 6.28;
	}
	if (p->angle < -6.28) {
		p->angle += 6.28;
	}
	// Regra do arredondamento do angulo
	fixAngle(p);
}

void addStr (player* p, float str) {
	if (p->strength + str < MAX_STR) {
		p->strength += str;
	}
	else {
		p->strength = MAX_STR;
	}
}

void subStr (player* p, float str) {
	if (p->strength - str > MIN_STR) {
		p->strength -= str;
	}
	else {
		p->strength = MIN_STR;
	}
}

void addScore (player* p, int points) {
	p->score += points;
}

void setScore (player* p, int points) {
	p->score = points;
}

void fixAngle (player* p) {
	char strAngle[30];
	int sign = 1;

	if (p->angle < 0) {
		sign = -1;
		p->angle = p->angle * -1;
	}

	sprintf(strAngle, "%1.2f", p->angle);
	strAngle[4] = '\0';

	p->angle = atof(strAngle);
	p->angle = p->angle * sign;
}

void initializePlayer (player* p) {
	p->score = 0;
	p->angle = DEFAULT_ANGLE;
}

void importShot (player* p, char* shot) {
	char strength[30];
	char angle[30];
	int i;

	strcpy(strength, shot);
	strength[5] = '\0';

	for (i=0; i < 5; i++) {
		angle[i] = shot[i+5];
	}
	angle[5] = '\0';

	p->strength = atof(strength);
	p->angle = atof(angle);
}

void exportShot (player* p, char* shot) {
	char strength[30];
	char angle[30];
	int i;

	sprintf(strength, "%2.2f", p->strength);
	if (strlen(strength) == 4) {
		for (i=4; i > 0; i--) {
			strength[i] = strength[i-1];
		}
		strength[0] = '0';
	}
	strength[5] = '\0';

	// FIXME: se angulo for maior que 6.28 volta a 0.00 (isso em playersTurn)
	sprintf(angle, "%1.2f", p->angle);
	if (strlen(angle) == 4) {
		for (i=4; i > 0; i--) {
			angle[i] = angle[i-1];
		}
		angle[0] = '+';
	}
	angle[5] = '\0';

	shot[0] = '\0';
	strcat(shot, strength);
	strcat(shot, angle);
	shot[10] = '\0';
}
