/*
  Copyright (C) 2007 Roberto Carraretto & Thiago Fassina Olimpio Carvalho

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "ray.h"

void initializeRay (ray* r, float x1, float y1, float x2, float y2) {
	setX(&r->p1, x1);
	setY(&r->p1, y1);
	setX(&r->p2, x2);
	setY(&r->p2, y2);

	r->a = y1 - y2;
	r->b = x2 - x1;
	r->c = (x1*y2) - (x2*y1);

	r->angle = atan(-1.0 * r->a / r->b);
}

point getP1 (ray* r) {
	return (r->p1);
}

point getP2 (ray* r) {
	return (r->p2);
}

float getRayAngle (ray* r) {
	return (r->angle);
}

float sqrPointRayDistance (ray* r, point* p0) {
	float num, den, dist;

	num = (r->a * getX(p0)) + (r->b * getY(p0)) + r->c;
	num = num * num;
	den = (r->a * r->a) + (r->b * r->b); 

	return (num / den);
}
