/*
  Copyright (C) 2007 Roberto Carraretto & Thiago Fassina Olimpio Carvalho

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "sound.h"

sounds loadSounds () {
	sounds som;
	som.bolabola = load_sample("sons/bolabola.wav");
	som.bolamesa = load_sample("sons/bolamesa.wav");
	som.bolataco = load_sample("sons/bolataco.wav");
	som.bolahole = load_sample("sons/bolahole.wav");
	som.ready = load_sample("sons/ready.wav");
	//carregar os sons aqui
	return(som);
}

int getVolume (vector speed, float energyLost) {
	float volume;

	vector recover;
	setVector(&recover, 1.0 / energyLost, 1.0 / energyLost);
	mulVector(&speed, &recover);

	volume = sqrt((getX(&speed) * getX(&speed)) + (getY(&speed) * getY(&speed)));

	if (volume > 5) { // se a velocidade for maior do que 5, o som toca em volume maximo
		return(255);
	}
	else {
		volume = abs(volume);
		if (volume < 50) { // volume minimo = 50
			return(50);
		}
		return(50*volume);
	}
}

int maxVolume (int a, int b) {
	if (a > b) {
		return(a);
	}
	return(b);
}

int getBal (float posX) {
	return((posX - 32)/2.9);
}
