#ifndef _TABLE
#define _TABLE

#define X_POSITION 33.0
#define Y_POSITION 33.0

#define X_DIMENSION 734.0
#define Y_DIMENSION 354.0

#define DEFAULT_ATTRITION 0.015

#define HOLE_RADIUS 13.5

#define TABLE_PIC_X 800
#define TABLE_PIC_Y 420

//Regions
// Retangulo maior
#define R1_X1 20
#define R1_Y1 55
#define R1_X2 780
#define R1_Y2 365

// Retangulo menor esquerda
#define R2_X1 55
#define R2_Y1 20
#define R2_X2 378
#define R2_Y2 400

// Retangulo menor direita
#define R3_X1 420
#define R3_Y1 R2_Y1
#define R3_X2 745
#define R3_Y2 R2_Y2
//no more regions

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <allegro.h>

#include "vector.h"
#include "ray.h"

typedef struct {
	vector center;
	float radius;
} hole;

typedef struct {
	vector position;
	vector dimension;
	float attrition;
	hole holes[6];
	ray rays[6][2];
	BITMAP* picture;
} table;

// Read Properties
float getAttrition (table* t);
vector getPositionTb (table* t);
float getXPositionTb (table* t);
float getYPositionTb (table* t);
vector getDimension (table* t);
float getXDimension (table* t);
float getYDimension (table* t);
vector getHoleCenter (table* t, int holeNum);
float getHoleRadius (table* t, int holeNum);
BITMAP* getTablePicture (table* t);
ray getRay (table* t, int hole, int index);

// Write Properties
void setTablePicture (table* t, BITMAP* p);

// Other
void initializeTable (table* t);
void freeTable (table* t);
int holeArea (point p);
int nearestHole (point p);

#endif

