/*
  Copyright (C) 2007 Roberto Carraretto & Thiago Fassina Olimpio Carvalho

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "vector.h"

// Read properties
float getX (vector* v) {
	return (v->x);
}

float getY (vector* v) {
	return (v->y);
}

// Write properties
void setX (vector* v, float x) {
	v->x = x;
}

void setY (vector* v, float y) {
	v->y = y;
}

void setVector (vector* v, float x, float y) {
	v->x = x;
	v->y = y;
}

void addVector (vector* myVector, vector* b) {
	myVector->x = myVector->x + b->x;
	myVector->y = myVector->y + b->y;
}

void subVector (vector* myVector, vector* b) {
	myVector->x = myVector->x - b->x;
	myVector->y = myVector->y - b->y;
}

void mulVector (vector* myVector, vector* b) {
	myVector->x = myVector->x * b->x;
	myVector->y = myVector->y * b->y;
}

float sqrDistance (vector* a, vector* b) {
	return ( (a->x - b->x) * (a->x - b->x) + (a->y - b->y) * (a->y - b->y) );
}

// Sentido anti-horario
void vectorRotation (vector* v, float a) {
	float vx;
	vx = v->x;
	v->x = sin(a)*v->y + cos(a)*v->x;
	v->y = cos(a)*v->y - sin(a)*vx;
}

// Angulo entre dois pontos em relacao ao eixo x+
float calculateAngle (point* p1, point* p2) {
	float angle;
	vector aux1, aux2;
	aux1 = *p1;
	aux2 = *p2;

	subVector(&aux1, &aux2);

	angle = atan2(getY(&aux1), getX(&aux1));
	return angle;
}
